﻿
@{
    ViewData["Title"] = "درخواست های وقت مشاوره";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}
@section scripts{
    <script src="~/ADMIN/JS/moment.js"></script>
    <script src="~/ADMIN/JS/moment-jalaali.js"></script>
}

<div class="wrapper-grid">
    <div class="k-rtl">
        @(Html.Kendo().Grid<ConsultationRequest>()
           .Name("grid")
           .Events(e => e.DataBound("SetTime"))
           .Events(e => e.Edit("Edit"))
           .Columns(columns =>
           {
               columns.Bound(c => c.FullName).Title("نام");
               columns.Bound(c => c.Mobile).Title("موبایل");
               columns.Bound(c => c.ApplicationUserId).Title("ایمیل");
               columns.ForeignKey(p => p.CounselorID, (System.Collections.IEnumerable)ViewData["Counselors"], "CounselorID", "Name").Title("نام مشاور");
               columns.Bound(c => c.AdviceTime).Format("{0:yyyy-MM-dd HH:mm:ss}").HtmlAttributes(new { style = "white-space: pre-line;text-align:center;letter-spacing: 2px;font-size: 13px;font-weight: 500;color: green;" }).Title("تاریخ مشاوره");
               columns.Bound(c => c.TimeRange).Title("بازه زمانی مشاوره").HtmlAttributes(new { style = "font-size: 13px;font-weight: 500;" });
               columns.Bound(c => c.Time).Title("تاریخ ثبت درخواست").Format("{0:yyyy-MM-dd HH:mm:ss}").HtmlAttributes(new { style = "font-weight: 500;" });
               columns.Bound(c => c.status).Title("وضعیت");
               columns.Bound(c => c.Description).Title("توضیحات");
               //columns.Command(command => { command.Destroy().Text(" "); }).Width(150);
           })

          .Groupable()
          .ColumnMenu()

          .Editable(editable =>
          {
              editable.Mode(GridEditMode.PopUp).Window(q => q.Width(480));
              editable.DisplayDeleteConfirmation("آیا از حذف این ردیف اطمینان دارید ؟ ");
          }
          )
          .Pageable(pageable => pageable
               .Refresh(true)
               .PageSizes(true)
               .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
               .PageSizes(new int[] { 10, 20, 30 }))
          .Navigatable()
          .Selectable(selectable =>
          {
              selectable.Mode(GridSelectionMode.Single);
              selectable.Type(GridSelectionType.Row);
          })
          .Sortable(sortable =>
          {
              sortable.SortMode(GridSortMode.SingleColumn);
          })
          //.ClientDetailTemplateId("payments")
          .Filterable()
          .Scrollable(s => s.Height("auto").Enabled(false))
          .DataSource(dataSource => dataSource
              .Ajax()
              .Sort(sort => sort.Add("ConsultationRequestID").Descending())
              .Model(model => model.Id(p => p.ConsultationRequestID))
              .Read(read => read.Action("ConsultationRequest_Read", "ConsultationRequest"))
              .Update(update => update.Action("ConsultationRequest_Update", "ConsultationRequest"))
              .Destroy(destroy => destroy.Action("ConsultationRequest_Destroy", "ConsultationRequest"))
          )
        )
    </div>
</div>

<script id="payments" type="text/kendo-tmpl">

    <div class="wrapper-grid">
        <div class="k-rtl">
            @(Html.Kendo().Grid<PaymentLog>()
                  .Name("PaymentLog_#=ConsultationRequestID#")
                  .Events(e => e.DataBound("SetTime2"))
              
                  .Columns(columns =>
                  {

                      columns.Bound(c => c.PaymentLogID).Title("شناسه");
                      columns.Bound(c => c.ReferenceBank).Title("بانک");
                      columns.Bound(c => c.IsSuccessful).Title("وضعیت پرداخت");
                      columns.Bound(c => c.RequestStatus).Title("وضعیت درخواست");
                      columns.Bound(c => c.ResponseCode).Title("کد پاسخ");
                      columns.Bound(c => c.Time).Format("{0:yyyy-MM-dd HH:mm:ss}").HtmlAttributes(new { style = "white-space: pre-line;text-align:center;letter-spacing: 2px;font-size: 12px;" }).Title("تاریخ ثبت");
                      columns.Bound(c => c.Amount).Title("مبلغ").Format("{0:n0} تومان");
                      columns.Bound(c => c.ResponseMessage).Title("پیام پاسخ");
                      columns.Command(command => { command.Edit().Text(" "); command.Destroy().Text(" "); }).Width(150);
                  })

                 .Groupable()
                 .ColumnMenu()
                 .Editable(editable =>
                 {
                     editable.Mode(GridEditMode.PopUp).Window(q => q.Width(700));
                     editable.DisplayDeleteConfirmation("آیا از حذف این ردیف اطمینان دارید ؟ ");
                 }
                 )
                 .Pageable(pageable => pageable
                      .Refresh(true)
                      .PageSizes(true)
                      .ButtonCount(10).Messages(m => m.ItemsPerPage("نمایش در هر صفحه"))
                      .PageSizes(new int[] { 10, 20, 30 }))
                 .Navigatable()
                 .Selectable(selectable =>
                 {
                     selectable.Mode(GridSelectionMode.Single);
                     selectable.Type(GridSelectionType.Row);
                 })
                 .Sortable(sortable =>
                 {
                     sortable.SortMode(GridSortMode.SingleColumn);
                 })
                 .Filterable()
                   .Scrollable(s => s.Height("auto").Enabled(false))
                 .DataSource(dataSource => dataSource
                     .Ajax()
                     .Sort(sort => sort.Add("PaymentLogID").Descending())
                     .Model(model => model.Id(p => p.PaymentLogID))
                     .Read(read => read.Action("PaymentLogs_Read", "PaymentLog", new { ConsultationRequestID = "#=ConsultationRequestID#" }))                   
                     .Destroy(destroy => destroy.Action("PaymentLogs_Destroy", "PaymentLog"))
                 )
                 .ToClientTemplate()
            )
        </div>
    </div>
</script>
<script>


    function SetTime() {

        var grid = this;

        grid.tbody.find("tr[role='row']").each(function (index, value) {
            var model = grid.dataItem(this);

            if (model.status){

                $(this).find("td:nth-child(8)")
                    .html("<i title='پرداخت شده' style='color:green;vertical-align:middle;' class='material-icons'>check_circle_outline</i>");
            }
            else
            {
                   $(this).find("td:nth-child(8)")
                    .html("<i title='عدم پرداخت' style='color:red; vertical-align:middle;' class='material-icons'>cancel</i>");
            }


            $(this).find('td:nth-child(5)').each(function (index, value) {
                            
                if ($(this).text().includes(":") && $(this).text().includes("-")) {                  
                    var result = moment($(this).text(), 'YYYY-M-D')
                        .format('jYYYY/jM/jDD')
                    result = result.replace(' ', '\n');
                    $(this).text(result)
                }
            })

            $(this).find('td:nth-child(7)').each(function (index, value) {
              
                if ($(this).text().includes(":") && $(this).text().includes("-")) {                  
                    var result = moment($(this).text(), 'YYYY-M-D')
                        .format('jYYYY/jM/jDD')
                    result = result.replace(' ', '\n');
                    $(this).text(result)
                }
            })
        });
    }

    function SetTime2() {

        //var grid = this;
        //grid.tbody.find("tr[role='row']").each(function (index, value) {
        //    var model = grid.dataItem(this);

        //    if (model.IsSuccessful) {

        //        $(this).find("td:nth-child(3)")
        //            .html("<i title='پرداخت شده' style='color:green;vertical-align:middle;' class='material-icons'>check_circle_outline</i>");
        //    } else {

        //        $(this).find("td:nth-child(3)")
        //            .html("<i title='عدم پرداخت' style='color:red; vertical-align:middle;' class='material-icons'>cancel</i>");
        //    }

        //    grid.tbody.find("tr[role='row']").each(function (index, value) {
        //        var model = grid.dataItem(this);
        //        $(this).find('td').each(function (index, value) {
        //            if ($(this).text().includes(":") && $(this).text().includes("-")) {
        //                var result = moment($(this).text(), 'YYYY-M-D HH:mm:ss')
        //                    .format('jYYYY/jM/jDD HH:mm:ss')
        //                result = result.replace(' ', '\n');
        //                $(this).text(result)
        //            }
        //        })
        //    });
        //});
    }

    function Edit(e) {

        $(e.container["0"].firstChild.children[0]).hide();
        $(e.container["0"].firstChild.children[1]).hide();
        $(e.container["0"].firstChild.children[4]).hide();
        $(e.container["0"].firstChild.children[5]).hide();
        $(e.container["0"].firstChild.children[8]).hide();
        $(e.container["0"].firstChild.children[9]).hide();

        var kendoWindow = e.container.data("kendoWindow");
        if (e.model.isNew()) {

        } else {
            kendoWindow.setOptions({
                title: "ویرایش مشاور"
            });
        }
    }
    function Error(e) {
        if (e.errors) {
            var message = "خطای رخ داده:\n";
            $.each(e.errors, function (key, value) {
                if ('errors' in value) {
                    $.each(value.errors, function () {
                        message += this + "\n";
                    });
                }
            });
            alert(message);
        }
    }

</script>

